package x64

import "encoding/binary"

// encodeNum encodes an instruction with up to two registers and a number parameter.
func encodeNum(code []byte, w byte, mod byte, reg byte, rm byte, number int, opCode8 byte, opCode32 byte) []byte {
	if SizeOf(int64(number)) == 1 {
		code = encode(code, w, mod, reg, rm, opCode8)
		return append(code, byte(number))
	}

	code = encode(code, w, mod, reg, rm, opCode32)
	return binary.LittleEndian.AppendUint32(code, uint32(number))
}
